# pz_LoopSelectionPlugin
# Initial code generated by Softimage SDK Wizard
# Executed Tue Oct 15 07:40:43 UTC+0200 2013 by Petr
# 
# Tip: To add a command to this plug-in, right-click in the 
# script editor and choose Tools > Add Command.
# 
# loop selection for polygons (works on points and edges too, even on object level ;) )
# Petr Zloty
# petr.zloty@gmail.com
# Version 0.1 released
# 3.9.2007
# Version 0.11 packed to plugin/command
# 7.15.2013

import win32com.client
from win32com.client import constants

null = None
false = 0
true = 1

from win32com.client import constants as c

xsi = Application
log = xsi.logmessage

def XSILoadPlugin( in_reg ):
	in_reg.Author = "Petr Zloty"
	in_reg.Name = "pz_LoopSelectionPlugin"
	in_reg.Major = 1
	in_reg.Minor = 0

	in_reg.RegisterCommand("pz_LoopSelection","pz_LoopSelection")
	#RegistrationInsertionPoint - do not remove this line

	return true

def XSIUnloadPlugin( in_reg ):
	strPluginName = in_reg.Name
	Application.LogMessage(str(strPluginName) + str(" has been unloaded."),constants.siVerbose)
	return true


def TempPPG():
	oRoot =  xsi.ActiveProject.ActiveScene.Root
	oCP = XSIFactory.CreateObject("CustomProperty")
	oCP.Name = "LoopPolyPop"
	oCP.AddParameter2("stepVal", c.siInt2, 2, 2, None, 2, 20, 0, 4, "Step")
	oCP.AddParameter2("selCheckb", c.siBool, False, None, None, None, None, 0, 4, "Select (off) / deselect (on)")

	oLayout = oCP.PPGLayout
	oLayout.Clear()

	oItem = oLayout.AddItem( "stepVal")
	oItem = oLayout.AddItem( "selCheckb")
	oLayout.Language = "PythonScript"

	bCancelled = xsi.InspectObj(oCP,"", "Step",  c.siModal, False)

	if (bCancelled == False):
		step = oCP.stepVal.Value
		Checkb = oCP.selCheckb.Value
		return [step, Checkb]
	else:
		return None

def LoopPoly(oSel, step):
	if oSel == None:
		return False

	try:	
		oOldColl = oSel(0).subcomponent.componentcollection
	except:
		oOldColl = XSIFactory.CreateObject("XSI.Collection")
		for oItem in oSel:
			oOldColl.Add(oItem)
			
	oNewColl = XSIFactory.CreateObject("XSI.Collection")
	
	xsi.RemoveFromSelection(oOldColl)
	i = 0
	while i < oOldColl.count:
		oNewColl.add(oOldColl(i))
		i += step
	xsi.SelectObj(oNewColl)
	return True
	
def LoopPolyDes(oSel, step):
	if oSel == None:
		return False
	
	try:
		oOldColl = oSel(0).subcomponent.componentcollection
	except:
		oOldColl = oSel
	oNewColl = XSIFactory.CreateObject("XSI.Collection")
	for oItem in oOldColl:
		oNewColl.Add(oItem)
		
	i = 0
	while i < oOldColl.count:
		oNewColl.Remove(oOldColl(i))
		i += step
	xsi.SelectObj(oNewColl)
	return True

def pz_LoopSelection_Init( in_ctxt ):
	oCmd = in_ctxt.Source
	oCmd.Description = "Select or deselect every Nth element of looped selection."
	oCmd.ReturnValue = true
	return true

def pz_LoopSelection_Execute():

	Application.LogMessage("pz_LoopSelection_Execute called",constants.siVerbose)
	# 
	oSel = xsi.selection

	step = TempPPG()
	if step != None:
		if (step[1]):
			LoopPolyDes(oSel, step[0])
		else:
			LoopPoly(oSel, step[0])
	# 
	return true

